// created on 2004-12-23 at 23:30

using System;
using Gtk;
using Glade;

public class Window_Import 
  {

  ToggleList DataFields_GtkTreeView;
  [Widget] Gtk.Window Window_Import_GtkWindow;
  //Gtk.TreeStore DataFields_Store_GtkTreeStore;
  [Widget] Gtk.ScrolledWindow ColumnListContainer_GtkScrolledWindow;
  
  // List buttons
  [Widget] Gtk.Button MoveUp_GtkButton;
  [Widget] Gtk.Button MoveDown_GtkButton;
  [Widget] Gtk.Button Open_GtkButton;
  [Widget] Gtk.Button OK_GtkButton;
  [Widget] Gtk.Entry Filename_GtkEntry;
  
  MovieDatabase DB;
  
  private void InitColumns() 
    {
    DataFields_GtkTreeView = new ToggleList();
    ColumnListContainer_GtkScrolledWindow.Add(DataFields_GtkTreeView);
    
    // Fill in datafield values
    for (int __i=0; __i < DB.DataField_Name.Length; __i++) 
      {
      if (DB.DataField_IsInternal[__i] == false) 
        DataFields_GtkTreeView.AppendItem(__i, false, DB.DataField_Name[__i]);
      }
    
    Window_Import_GtkWindow.ShowAll();
    
    }
  
  /* Create data mapping array from items in treeview */
/*  
public int[] CollectMapping() {
    TreeIter __iter = new TreeIter();
    
    // First find the number of toggled items
    DataFields_Store_GtkTreeStore.GetIterFirst(out __iter);
    
    int __count=0;
    bool __valid = true;
    
    while (__valid == true) {
      if (((bool) DataFields_Store_GtkTreeStore.GetValue(__iter, 1)) == true) __count++;
      __valid = DataFields_Store_GtkTreeStore.IterNext(ref __iter);
    }
    
    // EXCEPTION: Check if 0 toggled 
    if (__count == 0) {
      throw new Exception("You have to select at least one data field!");
    }
   
    // Then create the mapping
    int[] _Mapping = new int[__count];
    
    
    DataFields_Store_GtkTreeStore.GetIterFirst(out __iter);
    __valid = true;
    int __i=0;
    while (__valid == true) {
      if (((bool) DataFields_Store_GtkTreeStore.GetValue(__iter, 1)) == true) { 
	_Mapping[__i] = (int) DataFields_Store_GtkTreeStore.GetValue(__iter, 0);
	__i++;
      }
      
      __valid = DataFields_Store_GtkTreeStore.IterNext(ref __iter);
    }

    return _Mapping;
  }
*/
/*  
  void InitFields(MovieDatabase _DB) {
  
    DataFields_Store_GtkTreeStore = new Gtk.TreeStore(typeof(int), typeof(bool), typeof(string));
    DataFields_GtkTreeView.Model = DataFields_Store_GtkTreeStore;
    DataFields_GtkTreeView.CursorChanged += new EventHandler (OnFieldsRowSelected);
    DataFields_GtkTreeView.UnselectAll += new UnselectAllHandler (OnFieldsUnSelected);
				
    // Toggle Renderer
    CellRendererToggle TGRenderer= new CellRendererToggle ();
    TGRenderer.Activatable = true;
    TGRenderer.Toggled += new ToggledHandler(OnFieldsToggled);
    
    DataFields_GtkTreeView.AppendColumn ("Index", new CellRendererText (), "text", 0);
    DataFields_GtkTreeView.AppendColumn ("Bool", TGRenderer, "active", 1);
    DataFields_GtkTreeView.AppendColumn ("Name", new CellRendererText (), "text", 2);
    
    // Hide the Index Column
    TreeViewColumn __clmn = DataFields_GtkTreeView.GetColumn(0);
    __clmn.Visible = false;
    
    // Fill in datafield values
    for (int __i=0; __i < _DB.DataField_Name.Length; __i++) {
	TreeIter lastrow = DataFields_Store_GtkTreeStore.AppendValues();
	DataFields_Store_GtkTreeStore.SetValue(lastrow, 0, __i);
	DataFields_Store_GtkTreeStore.SetValue(lastrow, 1, false);
	DataFields_Store_GtkTreeStore.SetValue(lastrow, 2, _DB.DataField_Name[__i]);
    }
    
    // Make buttons inactive by default
    MoveUp_GtkButton.Sensitive = false;
    MoveDown_GtkButton.Sensitive = false;
    
    // Bind stuff
    MoveUp_GtkButton.Clicked += new EventHandler(OnMoveButtonsClicked);
    MoveDown_GtkButton.Clicked += new EventHandler(OnMoveButtonsClicked);
    Open_GtkButton.Clicked += new EventHandler(OnOpenButtonClicked);
    OK_GtkButton.Clicked += new EventHandler(OnOKClicked);
    
    
  }
*/
  
  /* Constructor */
  public Window_Import(MovieDatabase _DB) {
  
    Glade.XML gxml = new Glade.XML (null, "GUI.glade", "Window_Import_GtkWindow", null);
    gxml.Autoconnect (this);
    // TODO: DB co do without passing
    //InitFields(_DB);
    
    DB = _DB;

    // Make buttons inactive by default
    MoveUp_GtkButton.Sensitive = false;
    MoveDown_GtkButton.Sensitive = false;
    
    // Bind stuff
    MoveUp_GtkButton.Clicked += new EventHandler(OnMoveButtonsClicked);
    MoveDown_GtkButton.Clicked += new EventHandler(OnMoveButtonsClicked);
    Open_GtkButton.Clicked += new EventHandler(OnOpenButtonClicked);
    OK_GtkButton.Clicked += new EventHandler(OnOKClicked);

    InitColumns();
    Application.Run();
  }
  

  void OnFieldsToggled (object _o, ToggledArgs _args) {
  /*
    TreeIter __iter = new TreeIter();
    DataFields_Store_GtkTreeStore.GetIter(out __iter, new TreePath(_args.Path));
    // Get current toggle value
    bool _currentstate = (bool) DataFields_Store_GtkTreeStore.GetValue(__iter, 1);
    // Change toggle value
    DataFields_Store_GtkTreeStore.SetValue(__iter, 1, !_currentstate);
  */
    
  }
      
  void OnFieldsRowSelected  (object sender, EventArgs e) {
    MoveUp_GtkButton.Sensitive = true;
    MoveDown_GtkButton.Sensitive = true;				
    
  }

	
  void OnFieldsUnSelected (object o, UnselectAllArgs args) {
    MoveUp_GtkButton.Sensitive = false;
    MoveDown_GtkButton.Sensitive = false;				
    
  }

  
  /* Main import function */
  void OnOKClicked (object sender, EventArgs e) 
    {
    
    try 
      {
      int[] __Mapping = DataFields_GtkTreeView.GetToggledItems();
      // EXCEPTION: 0 items toggled
      if (__Mapping == null) throw new Exception("You have to select at least one data field!");
      if (Filename_GtkEntry.Text.Length == 0) throw new Exception("You have to select a file!");

      CSVImport Importer = new CSVImport(Filename_GtkEntry.Text, DB, __Mapping);
      int __count = Importer.Import();
      Importer.CloseFile();
      
      if (__count == 0) throw new Exception("Not a single file could be imported from the specified file! Please check if the column specification is right.");
      // Success
      MessageDialog md = new MessageDialog(Window_Import_GtkWindow, DialogFlags.DestroyWithParent, 
					   MessageType.Info, ButtonsType.Close, __count + 
                                           " movies were imported into the database.");
      md.Run();
      md.Destroy();
      // TODO: Close this window
      
      }
    catch (Exception excp) {
    // Fallback
    MessageDialog md = new MessageDialog(Window_Import_GtkWindow, DialogFlags.DestroyWithParent, 
                                         MessageType.Warning, ButtonsType.Close, excp.Message);
    
    md.Run();
    md.Destroy();
    
    return;
    }
    
  
  }

  
  void OnOpenButtonClicked (object sender, EventArgs e) {
    FileSelection _fs = new FileSelection ("Choose a file");
    _fs.Run ();
    Filename_GtkEntry.Text = _fs.Filename;
    _fs.Hide ();
  }

  
  void OnMoveButtonsClicked  (object sender, EventArgs e) {
  /*
    // TODO: Actually... this is EXTREMALY CLUMSY! Could be better? 
    
    TreeIter _this_iter = new TreeIter();
    
    TreeModel model = DataFields_Store_GtkTreeStore;
    
    TreeSelection clicked = DataFields_GtkTreeView.Selection;
    clicked.GetSelected(out model , out _this_iter);
    TreeIter _other_iter = _this_iter;
    
    int _this_iter_n = Convert.ToInt32(DataFields_Store_GtkTreeStore.GetPath(_this_iter).ToString());
    int _other_iter_n;
    
    if (sender == MoveUp_GtkButton) {
      if (_this_iter_n == 0) return;
      _other_iter_n = _this_iter_n - 1;
    }
    else {
      if (DataFields_Store_GtkTreeStore.IterNext(ref _other_iter) == false) return;
      _other_iter_n = _this_iter_n + 1;
    }
    
    DataFields_Store_GtkTreeStore.GetIter(out _other_iter, new TreePath((string)_other_iter_n.ToString()));
    DataFields_Store_GtkTreeStore.Swap(_this_iter, _other_iter);        		
  */
  }

  
  /* Window Closure */
  void OnWindowDeleteEvent (object o, DeleteEventArgs args) {
    System.Console.WriteLine("Quitting import options...");
    Application.Quit ();
   
  }
  
}
