/*
 * Copyright (C) 2004, 2005 Michael Dominic K. (http://www.mdk.org.pl)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

using System;


namespace CommonErrors {

    public class Plugins {
        
        public static readonly string NoTitle = "You have to provide a title of the movie!";
        public static readonly string BadCharset = "Some characters you entered cannot be converted to a format accepted by {0} search engine ({1} encoding). Please provide an alternate spelling";
        public static readonly string Downloading = "Downloading data from {0} ...";
        public static readonly string MovieNotFound = "The movie was not found in {0}. Try different spelling.";
        public static readonly string AmbigiousTitle = "The title you specified is ambigious. Please select the one you're interested in.";
        public static readonly string SearchResultsWindowTitle = "Select movie";
        public static readonly string Exception = "Internal exception has been thrown while executing the plugin! Please report this as a bug.\n\nException: {0}\nStackTrace: {1}";
        public static readonly string NoFile = "You have to select a file!";
    }

}
